/*
        This file is part of DISSECT.

        DISSECT is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        DISSECT is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with DISSECT.  If not, see <http://www.gnu.org/licenses/>.
*/


package dissect;

import beast.core.BEASTObject;
import beast.core.Input;
import beast.core.Loggable;
import beast.evolution.tree.Node;
import beast.evolution.tree.TreeInterface;

import java.io.PrintStream;
import java.util.List;

/**
 * Created by Graham on 27/02/14.
 */


/* I am copying ESS */

public class BirthDeathCollapseNClustersStatistic extends BEASTObject implements Loggable {
    public Input<TreeInterface> spptree =
            new Input<TreeInterface>("spptree", "species tree", Input.Validate.REQUIRED);
    public Input<BirthDeathCollapseModel> bdcm =
            new Input<BirthDeathCollapseModel>("bdcm", "birth death collapse model", Input.Validate.REQUIRED);


    @Override
    public void initAndValidate() {
//        try {
//            super.initAndValidate();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }



    @Override
    public void init(PrintStream out) throws Exception {
        out.print("NClusters\t");
    }

    @Override
    public void log(int nSample, PrintStream out) {
        out.print(""+getStatisticValue() + "\t");
    }

    @Override
    public void close(PrintStream out) {
        // nothing to do
    }

    private double getStatisticValue() {
        List<Node> inodes = spptree.get().getInternalNodes();
        int n =  0;
        for (Node node : inodes) {
            double h = node.getHeight();
            if (!BirthDeathCollapseModel.belowCollapseHeight(h)) {
                n++;
            }
        }
        return n+1;
    }



}
